﻿using NtApiDotNet;
using System;

namespace POC
{
    class Program
    {
        static NtKey WalkPath(string path)
        {
            string[] ps = path.Split(new[] { '\\' }, StringSplitOptions.RemoveEmptyEntries);
            NtKey curr = NtKey.Open(@"\REGISTRY", null, KeyAccessRights.MaximumAllowed);
            for (int i = 1; i < ps.Length; ++i)
            {
                NtKey next = NtKey.Open(ps[i], curr, KeyAccessRights.MaximumAllowed);
                curr.Close();
                curr = next;
            }
            return curr;
        }

        static void Main(string[] args)
        {
            try
            {
                const string TARGET = @"\REGISTRY\MACHINE\SOFTWARE";
                using (var silo_key = NtKey.Open(TARGET, null, KeyAccessRights.MaximumAllowed))
                {
                    Console.WriteLine("Silo Key Path: {0}", silo_key.FullPath);
                    Console.WriteLine("Subkey Count for Silo Key: {0}", silo_key.SubKeyCount);
                }
                using (var host_key = WalkPath(TARGET))
                {
                    Console.WriteLine("Host Key Path: {0}", host_key.FullPath);
                    Console.WriteLine("Subkey Count for Host Key: {0}", host_key.SubKeyCount);
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex);
            }
        }
    }
}
